//	xsetaseta@gmail.com
//  12-Salidas-OUTPUT
//	arduLed
//	12/04/2020
//	http://seta43.blogspot.com/
//	seta43.duckdns.org
//___________

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.util.Enumeration;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.io.IOException;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;
import gnu.io.SerialPortEvent;
import gnu.io.SerialPortEventListener;


public class arduLed extends JFrame implements SerialPortEventListener 
{
    JButton Bsend;
    static public JTextField valorOUT, valorIN;
    
    private BufferedReader bufferIN;
    private OutputStream output = null;
    SerialPort serialPort;
    private static  String PORT_NAME; // = "/dev/ttyUSB0";
    private static final int TIME_OUT = 2000;
    private static final int DATA_RATE = 9600;
    
    JRadioButton PIN2,PIN3,PIN4,PIN5,PIN6,PIN7,PIN8,PIN9,PIN10,PIN11,PIN12,PIN13;
    JButton EXIT,ON,OFF;
    JCheckBox DEBUG;
    int miDebug=0;
    
    public arduLed()
     {
		setLayout(new FlowLayout());
		
		JPanel p0 = new JPanel();
		p0.setLayout(new GridLayout(5, 1));
		p0.add(new JLabel("SALIDA "));
		valorOUT = new JTextField(20);
		p0.add(valorOUT);
		Bsend = new JButton("SEND");
		p0.add(Bsend);
		Bsend.addActionListener(new ProcSend());
		p0.add(new JLabel("RESPUESTA ARDUINO"));
		valorIN = new JTextField(20);
		p0.add(valorIN);
		
		JPanel p1 = new JPanel();
		p1.setLayout(new GridLayout(5, 3));

		PIN2= new JRadioButton("PIN2");
		PIN2.addActionListener(new miEvento());
		PIN2.setActionCommand("PIN2");
		p1.add(PIN2);
		PIN3= new JRadioButton("PIN3");
		PIN3.addActionListener(new miEvento());
		PIN3.setActionCommand("PIN3");
		p1.add(PIN3);
		PIN4= new JRadioButton("PIN4");
		PIN4.addActionListener(new miEvento());
		PIN4.setActionCommand("PIN4");
		p1.add(PIN4);
		PIN5= new JRadioButton("PIN5");
		PIN5.addActionListener(new miEvento());
		PIN5.setActionCommand("PIN5");
		p1.add(PIN5);
		PIN6= new JRadioButton("PIN6");
		PIN6.addActionListener(new miEvento());
		PIN6.setActionCommand("PIN6");
		p1.add(PIN6);
		PIN7= new JRadioButton("PIN7");
		PIN7.addActionListener(new miEvento());
		PIN7.setActionCommand("PIN7");
		p1.add(PIN7);
		
		PIN8= new JRadioButton("PIN8");
		PIN8.addActionListener(new miEvento());
		PIN8.setActionCommand("PIN8");
		p1.add(PIN8);
		PIN9= new JRadioButton("PIN9");
		PIN9.addActionListener(new miEvento());
		PIN9.setActionCommand("PIN9");
		p1.add(PIN9);
		PIN10= new JRadioButton("PIN10");
		PIN10.addActionListener(new miEvento());
		PIN10.setActionCommand("PIN10");
		p1.add(PIN10);
		PIN11= new JRadioButton("PIN11");
		PIN11.addActionListener(new miEvento());
		PIN11.setActionCommand("PIN11");
		p1.add(PIN11);
		PIN12= new JRadioButton("PIN12");
		PIN12.addActionListener(new miEvento());
		PIN12.setActionCommand("PIN12");
		p1.add(PIN12);
		PIN13= new JRadioButton("PIN13");
		PIN13.addActionListener(new miEvento());
		PIN13.setActionCommand("PIN13");
		p1.add(PIN13);
		
		ON= new JButton("ON");
		ON.addActionListener(new miEvento());
		ON.setActionCommand("ON");
		p1.add(ON);
		OFF= new JButton("OFF");
		OFF.addActionListener(new miEvento());
		OFF.setActionCommand("OFF");
		p1.add(OFF);
		
		DEBUG= new JCheckBox("Consola");
		DEBUG.addActionListener(new miEvento());
		DEBUG.setActionCommand("DEBUG");
		p1.add(DEBUG);
		
		

		JPanel p3 = new JPanel();
		EXIT= new JButton("EXIT");
		EXIT.addActionListener(new miEvento());
		EXIT.setActionCommand("EXIT");
		p3.add(EXIT,BorderLayout.SOUTH);
			
		JPanel p5 = new JPanel();
		p5.setLayout(new BorderLayout());
		p5.add(p0, BorderLayout.NORTH);
		p5.add(p1, BorderLayout.WEST);

		p5.add(p3, BorderLayout.SOUTH);
		add(p5, BorderLayout.SOUTH);
		
		setSize(350, 340);
		setMinimumSize(new Dimension(350, 340));
		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		initializeArduinoConnection();
     } 
     
     class miEvento implements ActionListener 
	{
		public void actionPerformed(ActionEvent e)
		{
			String comando = e.getActionCommand();
			if(miDebug==1)System.out.println("EVENTO=" + comando);
					
			if (comando.equals("PIN2"))
				{
					 if(PIN2.isSelected()==true)						
						 sendData("SET 2,1\n");
						else
						 sendData("SET 2,0\n");
				}
			if (comando.equals("PIN3"))
				{
					 if(PIN3.isSelected()==true)						
						 sendData("SET 3,1\n");
						else
						 sendData("SET 3,0\n");
				}
			if (comando.equals("PIN4"))
				{
					 if(PIN4.isSelected()==true)						
						 sendData("SET 4,1\n");
						else
						 sendData("SET 4,0\n");
				}
			if (comando.equals("PIN5"))
				{
					 if(PIN5.isSelected()==true)						
						 sendData("SET 5,1\n");
						else
						 sendData("SET 5,0\n");
				}
			if (comando.equals("PIN6"))
				{
					 if(PIN6.isSelected()==true)						
						 sendData("SET 6,1\n");
						else
						 sendData("SET 6,0\n");
				}
			if (comando.equals("PIN7"))
				{
					 if(PIN7.isSelected()==true)						
						 sendData("SET 7,1\n");
						else
						 sendData("SET 7,0\n");
				}
			if (comando.equals("PIN8"))
				{
					 if(PIN8.isSelected()==true)						
						 sendData("SET 8,1\n");
						else
						 sendData("SET 8,0\n");
				}
			if (comando.equals("PIN9"))
				{
					 if(PIN9.isSelected()==true)						
						 sendData("SET 9,1\n");
						else
						 sendData("SET 9,0\n");
				}
			if (comando.equals("PIN10"))
				{
					 if(PIN10.isSelected()==true)						
						 sendData("SET 10,1\n");
						else
						 sendData("SET 10,0\n");
				}				
			if (comando.equals("PIN11"))
				{
					 if(PIN11.isSelected()==true)						
						 sendData("SET 11,1\n");
						else
						 sendData("SET 11,0\n");
				}
			if (comando.equals("PIN12"))
				{
					 if(PIN12.isSelected()==true)						
						 sendData("SET 12,1\n");
						else
						 sendData("SET 12,0\n");
				}
			if (comando.equals("PIN13"))
				{
					 if(PIN13.isSelected()==true)						
						 sendData("SET 13,1\n");
						else
						 sendData("SET 13,0\n");
				}				
				
			if (comando.equals("ON"))
				{
					PIN2.setSelected(true);PIN3.setSelected(true);PIN4.setSelected(true);PIN5.setSelected(true);
					PIN6.setSelected(true);PIN7.setSelected(true);PIN8.setSelected(true);PIN9.setSelected(true);
				 	PIN10.setSelected(true);PIN11.setSelected(true);PIN12.setSelected(true);PIN13.setSelected(true);
				 for(int z=2;z<14;z++)
					{sendData("SET "+ z + ",1\n");
					  try   { Thread.sleep(50);	}
					  catch (Exception h) {   System.out.println(e);	}
					}
				}
			if (comando.equals("OFF"))
				{
					PIN2.setSelected(false);PIN3.setSelected(false);PIN4.setSelected(false);PIN5.setSelected(false);
					PIN6.setSelected(false);PIN7.setSelected(false);PIN8.setSelected(false);PIN9.setSelected(false);
				 	PIN10.setSelected(false);PIN11.setSelected(false);PIN12.setSelected(false);PIN13.setSelected(false);
				 for(int z=2;z<14;z++)
					{sendData("SET "+ z + ",0\n");
					  try   { Thread.sleep(50);	}
					  catch (Exception h) {   System.out.println(e);	}
					}
				}
			if (comando.equals("DEBUG"))
				{
					 if(DEBUG.isSelected()==true)						
						 miDebug=1;
						else
						 miDebug=0;
				}	
			if (comando.equals("EXIT")) 	System.exit(0);
		}
	}
	
     
     
    
    public static void main(String args[]) 
		{
			if(args.length==1)
				{ PORT_NAME = args[0];	}
			 else
				{ PORT_NAME= "/dev/ttyUSB0";}
		 System.out.println("PORT_"+ PORT_NAME);

		 arduLed ventana = new arduLed();
		 System.out.println("INICIO");	
		 
		}
		

	public synchronized void serialEvent(SerialPortEvent oEvent) 
		{
			//System.out.println( "EVENTO SERIE "+ oEvent.getEventType() );
			if (oEvent.getEventType() == SerialPortEvent.DATA_AVAILABLE) 
			{
				try {
					String inputLine=bufferIN.readLine();
					if(miDebug==1)System.out.println(inputLine);
					valorIN.setText(inputLine);
					
					} 
				catch (Exception e) 
					{
					System.err.println(e.toString());
					}
			}
		}
				
    class ProcSend implements ActionListener 
		{
		 public void actionPerformed(ActionEvent e) 
			{
				String valor = valorOUT.getText();
				if(miDebug==1) System.out.println( "SEND=" + valor);
				sendData(valor + "\n");
			}
		}
		
	private void sendData(String data) 
		{
			try 
				{
					output.write(data.getBytes());
				} 
			catch(IOException e) 
				{
					showError("Error sending data");
					System.exit(ERROR);
				}
		}
    
    private void showError(String errorMessage) 
		{ System.out.println( "ERROR " + errorMessage);  }
	
			
  public void initializeArduinoConnection() 
    {
		CommPortIdentifier portId = null;
		Enumeration portEnum = CommPortIdentifier.getPortIdentifiers();
	// iterate through, looking for the port
		while (portEnum.hasMoreElements()) 
			{
			CommPortIdentifier currPortId = (CommPortIdentifier)
			portEnum.nextElement();
			if (PORT_NAME.equals(currPortId.getName())) {
			portId = currPortId;
			break;
			}
		}
		if (portId == null) {
			System.out.println( "Could not find port.");
			JOptionPane.showMessageDialog(null, "Could not find port." + PORT_NAME);
			System.exit(ERROR);
			return;
		}
		
		try 
			{
		// open serial port, and use class name for the appName.
				serialPort = (SerialPort) portId.open(this.getClass().getName(), TIME_OUT);
		// set port parameters
				serialPort.setSerialPortParams(DATA_RATE, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
		// open the streams
				output = serialPort.getOutputStream();
				bufferIN = new BufferedReader(new InputStreamReader(serialPort.getInputStream()));
				serialPort.addEventListener(this);
				serialPort.notifyOnDataAvailable(true);
				System.out.println( "OK port." + PORT_NAME);
			}
		catch(Exception e) 
			{
				System.out.println( "ERROR configuracion port." + PORT_NAME);
				JOptionPane.showMessageDialog(null, "ERROR configuracion port." + PORT_NAME);
				System.exit(ERROR);
			}
    }
							
		
}





